import 'dart:io';

import 'package:flutter/foundation.dart';
import 'package:google_mobile_ads/google_mobile_ads.dart';

class AdState {
  Future<InitializationStatus> initialization;

  AdState(this.initialization);

  static String get verbOrModeSelectionBannerAdUnitId => Platform.isAndroid
      ? 'ca-app-pub-9014261072038331/6583813312'
      : 'ca-app-pub-9014261072038331/6544548195';

  static String get multiConjugationSelectionFooterAdUnitId =>
      Platform.isAndroid
          ? 'ca-app-pub-9014261072038331/7140564125'
          : 'ca-app-pub-9014261072038331/5746471842';

  static String get conjugationSelectionFooterAdUnitId => Platform.isAndroid
      ? 'ca-app-pub-9014261072038331/5799562297'
      : 'ca-app-pub-9014261072038331/7111524403';

  BannerAdListener get adListener => _adListener;

  final BannerAdListener _adListener = BannerAdListener(
    onAdLoaded: (ad) {
      if (kDebugMode) {
        print('onAdLoaded');
      }
    },
    onAdClosed: (ad) {
      if (kDebugMode) {
        print('onAdClosed');
      }
    },
    onAdFailedToLoad: (ad, addError) {
      if (kDebugMode) {
        print('onAdFailedToLoad');
      }
    },
    onAdImpression: (ad) {
      if (kDebugMode) {
        print('onAdImpression');
      }
    },
    onAdOpened: (ad) {
      if (kDebugMode) {
        print('onAdOpened');
      }
    },
    onAdWillDismissScreen: (ad) {
      if (kDebugMode) {
        print('onAdWillDismissScreen');
      }
    },
    onPaidEvent: (ad, addError, precisionType, event) {
      if (kDebugMode) {
        print('onPaidEvent');
      }
    },
  );
}
