import 'package:flutter/material.dart';

class CardinalitySelection with ChangeNotifier {
  bool _singularEnabled;
  bool _pluralEnabled;
  bool _dirty = false;

  bool get singularEnabled => _singularEnabled;
  bool get pluralEnabled => _pluralEnabled;
  bool get isDirty => _dirty;

  CardinalitySelection(this._singularEnabled, this._pluralEnabled);

  void toggleSingularEnabled() {
    _singularEnabled = !_singularEnabled;
    if (!_singularEnabled && !_pluralEnabled) {
      _pluralEnabled = true;
      notifyListeners();
    }
    notifyListeners();
  }

  void togglePluralEnabled() {
    _pluralEnabled = !_pluralEnabled;
    if (!_singularEnabled && !_pluralEnabled) {
      _singularEnabled = true;
      notifyListeners();
    }
    notifyListeners();
  }

  void markDirty() {
    _dirty = true;
  }

  void clearDirty() {
    _dirty = false;
  }
}
