import 'package:flutter/material.dart';

import '../util/text_size_limiter.dart';

class ScoreWidget extends StatelessWidget {
  final int actualScore;
  final int totalScore;

  const ScoreWidget(this.actualScore, this.totalScore, {Key? key})
      : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Padding(
      padding: const EdgeInsets.fromLTRB(20, 5, 20, 5),
      child: Card(
          elevation: 10,
          child: ListTile(
            title: Container(
              padding: const EdgeInsets.fromLTRB(5, 5, 5, 5),
              child: Text(
                "Score:",
                style: const TextStyle(
                  color: Colors.blue,
                  fontSize: 25,
                ),
                textScaleFactor: TextSizeLimiter.textScaleFactor(context),
              ),
            ),
            trailing: Container(
              padding: const EdgeInsets.fromLTRB(75, 5, 30, 5),
              child: Text(
                "$actualScore/$totalScore",
                style: const TextStyle(
                  color: Colors.blue,
                  fontSize: 25,
                ),
                textScaleFactor: TextSizeLimiter.textScaleFactor(context),
              ),
            ),
          )),
    );
  }
}
