import 'package:cramr_ui_lib/model/conjugation.dart';
import 'package:flutter_test/flutter_test.dart';

void main() {
  group('general tests for the conjugation', () {
    test('constructor and getters', () {
      const String _mode = 'mode';
      const String _tense = 'tense';
      const List<String> _conjugation = [
        'first',
        'second',
        'third',
        'fourth',
        'fifth',
        'sixth'
      ];
      Conjugation model = Conjugation(_mode, _tense, _conjugation);
      expect(_mode, model.mode);
      expect(_tense, model.tense);
      for (var element in _conjugation) {
        expect(true, model.conjugation.contains(element));
      }
      for (int i = 0; i < _conjugation.length; i++) {
        expect(_conjugation[i], model.conjugation[i]);
      }
    });
    test('test the identifier', () {
      const String _mode = 'mode';
      const String _tense = 'tense';
      const List<String> _conjugation = [
        'first',
        'second',
        'third',
        'fourth',
        'fifth',
        'sixth'
      ];
      Conjugation model = Conjugation(_mode, _tense, _conjugation);
      expect(_mode, model.mode);
      expect(_tense, model.tense);
      expect(_mode + '_' + _tense, model.getIdentifier());
    });
  });
}
